#! /bin/bash
declare __fData="test.log"
declare __fPattern="pattern.txt"
declare __fOut=""
declare __sPattern=""
declare -i __cnt=0
declare __start=""
declare __end=""
declare __time=""

function getTimeSpan()
{
	local -i __errCode=0
	local -i __start=${1}
	local -i __stop=${2}
	local _ts="${3}"
	local __ts=""
	__ts=$(\
			awk \
			-v t2=${__stop} \
			-v t1=${__start} \
			'BEGIN{\
					t = t2 - t1; \
					if(t > 0) \
						{\
							d = int(t / 86400); \
							h = int((t - d * 86400) / 3600); \
							m = int((t - d * 86400 - h * 3600) / 60); \
							s = t - d * 86400 - h * 3600 - m * 60; \
							if(d > 0) \
								ts = d" d "h" h "m" m "s" s ";\
							else if(h > 0) \
								ts = h" h "m" m "s" s ";\
							else if(m > 0) \
								ts = m" m "s" s ";\
							else \
								ts = s" s"\
						}\
					else \
						ts=0" s"; \
						print ts\
				}' \
			2>&1\
		)
	__errCode=$?

	if (( ${__errCode} == 0 ));then
		eval ${_ts}='${__ts}'
	fi

	return ${__errCode}
}

__sPattern=$(cat ${__fPattern})
#echo "__sPattern: '${__sPattern}'"
__start=$(date +%s)
__cnt=$(grep -c "${__sPattern}" ${__fData})
__end=$(date +%s)
getTimeSpan ${__start} ${__end} __time
__fOut=result_$(date "+%Y-%m-%d_%H-%M-%S.%N").log
echo "String count:              ${__cnt}"> "${__fOut}"
echo "Elapsed time:              ${__time}" >> "${__fOut}"
echo "Platform:                  $(uname -a)" >> "${__fOut}"
systeminfo | findstr /B /C:"OS Name" /C:"OS Version" >> "${__fOut}"